
#include <cotopha.h>


//
// O[oIuWFNg
//
shared Window		screen ;
shared InputFilter	input ;

//
// O[o֐
//
WndSpriteCmd & GetCommand( int nTimeout = INFINITE ) ;
bool DispatchCommand( WndSpriteCmd & wscmd ) ;
void WaitSprite( Sprite & sprite ) ;

enum	ExceptionCode
{
	Exit
} ;

void Fadein( Sprite & sprite, int nPriority, String strFileName ) ;
void Fadeout( Sprite & sprite ) ;
void Run( void ) ;


//////////////////////////////////////////////////////////////////////////////
// Gg|Cg
//////////////////////////////////////////////////////////////////////////////

int main()
{
	screen.CreateDisplay
		( "Model View Sample",
			Window::Copperation::Window, 640, 480 ) ;
	screen.SetOptionalFuncFlag
		( screen.GetOptionalFuncFlag()
			| Window::Flag::AllowClose
			| Window::Flag::AllowMinimize
			| Window::Flag::VariableWindowSize
			| Window::Flag::AllowMaximize ) ;
	screen.ShowCursor( true ) ;
	screen.EnableCommandQueue( true ) ;

	input.LoadInputFilter( "input.xml" ) ;
	input.OpenFilter( InputFilter::Type::Below, screen ) ;

	Sprite	sprBG ;
	try
	{
		Fadein( sprBG, 0x100, "hatomimi.bmp" ) ;
		Run() ;
		Fadeout( sprBG ) ;
	}
	catch ( int code )
	{
	}

	screen.CloseDisplay() ;

	return	0 ;
}


//////////////////////////////////////////////////////////////////////////////
// R}h擾
//////////////////////////////////////////////////////////////////////////////

WndSpriteCmd & GetCommand( int nTimeout )
{
	WndSpriteCmd &	wscmd = WndSpriteCmd ;
	if ( screen.GetCommand( wscmd, nTimeout ) == eslErrSuccess )
	{
		if ( !DispatchCommand( wscmd ) )
		{
			return	wscmd ;
		}
	}
	return	null ;
}


//////////////////////////////////////////////////////////////////////////////
// VXeR}h
//////////////////////////////////////////////////////////////////////////////

bool DispatchCommand( WndSpriteCmd & wscmd )
{
	switch ( wscmd.strID )
	{
	case	SysCommandId::AppExit:
		throw	ExceptionCode::Exit ;
	}
	return	false ;
}


//////////////////////////////////////////////////////////////////////////////
// XvCgAj[V҂
//////////////////////////////////////////////////////////////////////////////

void WaitSprite( Sprite & sprite )
{
	while ( sprite.IsActivation() )
	{
		//  P Sleep łǂÅԏIłȂ
		GetCommand( 33 ) ;
	}
}


//////////////////////////////////////////////////////////////////////////////
// XvCgtF[hC
//////////////////////////////////////////////////////////////////////////////

void Fadein( Sprite & sprite, int nPriority, String strFileName )
{
	SpriteParam	sp ;
	sprite.LoadImage( strFileName ) ;
	//
	ImageInfo&	infImage = sprite.GetImageInfo() ;
	if ( infImage === null )
	{
		return ;
	}
	sprite.GetParameter( sp ) ;
	sp.ptDstPos = Point( 320, 240 ) ;
	sp.ptRevCenter.x = infImage.nImageWidth / 2 ;
	sp.ptRevCenter.y = infImage.nImageHeight / 2 ;
	sp.nTransparency = 0x100 ;
	sprite.SetParameter( sp ) ;
	//
	screen.Lock() ;
	screen.AddSprite( nPriority, sprite ) ;
	sprite.SetVisible( true ) ;
	sprite.SetBlendingEnvelope( 0 ) ;
	sprite.BeginActivation( 1000 ) ;
	screen.Unlock() ;
	//
	WaitSprite( sprite ) ;
}


//////////////////////////////////////////////////////////////////////////////
// XvCgtF[hAEg
//////////////////////////////////////////////////////////////////////////////

void Fadeout( Sprite & sprite )
{
	screen.Lock() ;
	sprite.SetBlendingEnvelope( 0x100 ) ;
	sprite.BeginActivation( 1000 ) ;
	screen.Unlock() ;
	//
	WaitSprite( sprite ) ;
	//
	screen.Lock() ;
	screen.DetachSprite( sprite ) ;
	screen.Unlock() ;
}


//////////////////////////////////////////////////////////////////////////////
// C[v
//////////////////////////////////////////////////////////////////////////////

void Run( void )
{
	//
	// IuWFNg
	//
	RenderSprite	render ;
	ModelJoint		jointRoot ;
	PolygonModel	model ;
	//
	model.LoadModel( "hayabusa.mdf" ) ;
	//
	// f\ݒ
	//
	int			iSubJoint = jointRoot.AddSubJoint() ;
	ModelJoint&	jointModel = jointRoot[iSubJoint] ;
	//
	jointModel.AddModelRef( model ) ;
	jointModel.InitializeMatrix() ;
	jointModel.RotateOnX( -20 ) ;
	jointModel.MagnifyByVector( 3, 3, 3 ) ;
	//
	// ݒ
	//
	LightEntry[]	lights ;
	//
	// 
	lights[0].nLightType = E3D_AMBIENT_LIGHT ;
	lights[0].rgbColor = 0x204060 ;
	//
	// 
	lights[1].nLightType = E3D_VECTOR_LIGHT ;
	lights[1].rgbColor = 0xFFFFFF ;
	lights[1].rBrightness = 1.0 ;
	lights[1].vecLight.x = 1 ;
	lights[1].vecLight.y = 1 ;
	lights[1].vecLight.z = 1 ;
	//
	// 3D \
	//
	screen.CreateZBuffer() ;
	screen.SetScreenPosition( 320, 240, 1024 ) ;
	//
	screen.Lock() ;
	//
	render.Initialize( screen, 0 ) ;
	//
	// J
	render.SetViewPoint( Vector( 0, 0, -1024 ), Vector( 0, 0, 0 ), 0 ) ;
	//
	// [gWCg
	render.AttachRootJoint( jointRoot ) ;
	render.UpdateRendering() ;
	//
	// 
	render.SetLightEntries( lights ) ;
	//
	// Aj[Vݒ
	Bezier3D	bzRotate ;
	bzRotate.SetLine( 0, 0, 0, 0, 360, 0, 1, 1 ) ;
	jointRoot.SetBezierCurve( , bzRotate ) ;
	jointRoot.BeginActivation( 10000, AnimationLoopType::Loop ) ;
	//
	screen.Unlock() ;
	//
	// ̖[v
	//
	try
	{
		for ( ; ; )
		{
			GetCommand() ;
		}
	}
	catch ( int code )
	{
	}
	//
	// I
	//
	screen.Lock() ;
	render.AttachRootJoint( null ) ;
	render.Release() ;
	screen.Unlock() ;
}

