
#include <cotopha.h>


//
// O[oIuWFNg
//
shared Window		screen ;
shared InputFilter	input ;

//
// O[o֐
//
WndSpriteCmd & GetCommand( int nTimeout = INFINITE ) ;
bool DispatchCommand( WndSpriteCmd & wscmd ) ;
void WaitSprite( Sprite & sprite ) ;

enum	ExceptionCode
{
	Exit
} ;

void Fadein( Sprite & sprite, int nPriority, String strFileName ) ;
void Fadeout( Sprite & sprite ) ;
void Run( Sprite & sprite ) ;


//////////////////////////////////////////////////////////////////////////////
// Gg|Cg
//////////////////////////////////////////////////////////////////////////////

int main()
{
	screen.CreateDisplay
		( "Sprite Sample", Window::Copperation::Window, 640, 480 ) ;
	screen.SetOptionalFuncFlag
		( screen.GetOptionalFuncFlag()
			| Window::Flag::AllowClose
			| Window::Flag::AllowMinimize
			| Window::Flag::VariableWindowSize
			| Window::Flag::AllowMaximize ) ;
	screen.ShowCursor( true ) ;
	screen.EnableCommandQueue( true ) ;

	input.LoadInputFilter( "input.xml" ) ;
	input.OpenFilter( InputFilter::Type::Below, screen ) ;

	try
	{
		Sprite	sprBG ;
		Fadein( sprBG, 0, "hatomimi.bmp" ) ;
		Run( sprBG ) ;
		Fadeout( sprBG ) ;
	}
	catch ( int code )
	{
	}

	screen.CloseDisplay() ;

	return	0 ;
}


//////////////////////////////////////////////////////////////////////////////
// R}h擾
//////////////////////////////////////////////////////////////////////////////

WndSpriteCmd & GetCommand( int nTimeout )
{
	WndSpriteCmd &	wscmd = WndSpriteCmd ;
	if ( screen.GetCommand( wscmd, nTimeout ) == eslErrSuccess )
	{
		if ( !DispatchCommand( wscmd ) )
		{
			return	wscmd ;
		}
	}
	return	null ;
}


//////////////////////////////////////////////////////////////////////////////
// VXeR}h
//////////////////////////////////////////////////////////////////////////////

bool DispatchCommand( WndSpriteCmd & wscmd )
{
	switch ( wscmd.strID )
	{
	case	SysCommandId::AppExit:
		throw	ExceptionCode::Exit ;
	}
	return	false ;
}


//////////////////////////////////////////////////////////////////////////////
// XvCgAj[V҂
//////////////////////////////////////////////////////////////////////////////

void WaitSprite( Sprite & sprite )
{
	while ( sprite.IsActivation() )
	{
		//  P Sleep łǂÅԏIłȂ
		GetCommand( 33 ) ;
	}
}


//////////////////////////////////////////////////////////////////////////////
// XvCgtF[hC
//////////////////////////////////////////////////////////////////////////////

void Fadein( Sprite & sprite, int nPriority, String strFileName )
{
	SpriteParam	sp ;
	sprite.LoadImage( strFileName ) ;
	//
	ImageInfo&	infImage = sprite.GetImageInfo() ;
	if ( infImage === null )
	{
		return ;
	}
	sprite.GetParameter( sp ) ;
	sp.ptDstPos = Point( 320, 240 ) ;
	sp.ptRevCenter.x = infImage.nImageWidth / 2 ;
	sp.ptRevCenter.y = infImage.nImageHeight / 2 ;
	sp.nTransparency = 0x100 ;
	sprite.SetParameter( sp ) ;
	//
	screen.Lock() ;
	screen.AddSprite( nPriority, sprite ) ;
	sprite.SetVisible( true ) ;
	sprite.SetBlendingEnvelope( 0 ) ;
	sprite.BeginActivation( 1000 ) ;
	screen.Unlock() ;
	//
	WaitSprite( sprite ) ;
}


//////////////////////////////////////////////////////////////////////////////
// XvCgtF[hAEg
//////////////////////////////////////////////////////////////////////////////

void Fadeout( Sprite & sprite )
{
	screen.Lock() ;
	sprite.SetBlendingEnvelope( 0x100 ) ;
	sprite.BeginActivation( 1000 ) ;
	screen.Unlock() ;
	//
	WaitSprite( sprite ) ;
	//
	screen.Lock() ;
	screen.DetachSprite( sprite ) ;
	screen.Unlock() ;
}


//////////////////////////////////////////////////////////////////////////////
// C[v
//////////////////////////////////////////////////////////////////////////////

void Run( Sprite & sprite )
{
	//
	// WCpbhEL[{[hŉ摜ړ
	// @ or A{^ŏI
	//
	input.FlushJoyButtonPushed() ;
	//
	for ( ; ; )
	{
		screen.Lock() ;
		Point	pos = sprite.GetPosition() ;
		if ( input.IsJoyButtonPushing( jbUp ) )
		{
			pos.y -= 4 ;
		}
		if ( input.IsJoyButtonPushing( jbDown ) )
		{
			pos.y += 4 ;
		}
		if ( input.IsJoyButtonPushing( jbLeft ) )
		{
			pos.x -= 4 ;
		}
		if ( input.IsJoyButtonPushing( jbRight ) )
		{
			pos.x += 4 ;
		}
		sprite.MovePosition( pos.x, pos.y ) ;
		screen.Unlock() ;
		//
		if ( (input.GetJoyButtonPushed( jbButton1 ) > 0)
			|| (input.GetJoyButtonPushed( jbButton2 ) > 0) )
		{
			break ;
		}
		GetCommand( 33 ) ;
	}
}


