
#include <cotopha.h>


//
// O[oIuWFNg
//
shared Window		screen ;
shared InputFilter	input ;

//
// O[o֐
//
WndSpriteCmd & GetCommand( int nTimeout = INFINITE ) ;
bool DispatchCommand( WndSpriteCmd & wscmd ) ;
void WaitSprite( Sprite & sprite ) ;

enum	ExceptionCode
{
	Exit
} ;

void Fadein( Sprite & sprite, int nPriority, String strFileName ) ;
void Fadeout( Sprite & sprite ) ;
void Run( void ) ;


//////////////////////////////////////////////////////////////////////////////
// XvCg̃tbNNX
//////////////////////////////////////////////////////////////////////////////

class	DraggableSprite	: public Sprite,
							public SpriteMouseInterface,
							public SpriteKeyInterface
{
protected:
	Resource	m_rsNormal, m_rsHilight ;
	bool		m_flagTracking = false ;
	Point		m_ptTrackBase ;

public:
	// 摜ǂݍ
	void LoadImages( String strNormal, String strHilight ) ;

public:
	// SpriteMouseInterface I[o[Ch
	virtual void OnMouseMove
				( Sprite& sprite, int xPos, int yPos ) ;
	virtual void OnMouseLeave( Sprite& sprite ) ;
	virtual bool OnMouseWheel
				( Sprite& sprite,
					int zDelta, int xPos, int yPos ) ;
	virtual bool OnLButtonDown
				( Sprite& sprite, int xPos, int yPos ) ;
	virtual bool OnLButtonUp
				( Sprite& sprite, int xPos, int yPos ) ;
	virtual bool OnLButtonDblClk
				( Sprite& sprite, int xPos, int yPos ) ;
	virtual bool OnRButtonDown
				( Sprite& sprite, int xPos, int yPos ) ;
	virtual bool OnRButtonUp
				( Sprite& sprite, int xPos, int yPos ) ;
	virtual bool OnRButtonDblClk
				( Sprite& sprite, int xPos, int yPos ) ;

public:
	// SpriteKeyInterface I[o[Ch
	virtual bool OnKeyDown( Sprite& sprite, int nVirtKey ) ;
	virtual bool OnKeyUp( Sprite& sprite, int nVirtKey ) ;

} ;



//////////////////////////////////////////////////////////////////////////////
// Gg|Cg
//////////////////////////////////////////////////////////////////////////////

int main()
{
	screen.CreateDisplay
		( "Sprite Hook Sample",
			Window::Copperation::Window, 640, 480 ) ;
	screen.SetOptionalFuncFlag
		( screen.GetOptionalFuncFlag()
			| Window::Flag::AllowClose
			| Window::Flag::AllowMinimize
			| Window::Flag::VariableWindowSize
			| Window::Flag::AllowMaximize ) ;
	screen.ShowCursor( true ) ;
	screen.EnableCommandQueue( true ) ;

	input.LoadInputFilter( "input.xml" ) ;
	input.OpenFilter( InputFilter::Type::Below, screen ) ;

	Sprite	sprBG ;
	try
	{
		Fadein( sprBG, 0x100, "hatomimi.bmp" ) ;
		Run() ;
	}
	catch ( int code )
	{
	}
	try
	{
		Fadeout( sprBG ) ;
	}
	catch ( int code )
	{
	}

	screen.CloseDisplay() ;

	return	0 ;
}


//////////////////////////////////////////////////////////////////////////////
// R}h擾
//////////////////////////////////////////////////////////////////////////////

WndSpriteCmd & GetCommand( int nTimeout )
{
	WndSpriteCmd &	wscmd = WndSpriteCmd ;
	if ( screen.GetCommand( wscmd, nTimeout ) == eslErrSuccess )
	{
		if ( !DispatchCommand( wscmd ) )
		{
			return	wscmd ;
		}
	}
	return	null ;
}


//////////////////////////////////////////////////////////////////////////////
// VXeR}h
//////////////////////////////////////////////////////////////////////////////

bool DispatchCommand( WndSpriteCmd & wscmd )
{
	switch ( wscmd.strID )
	{
	case	SysCommandId::AppExit:
		throw	ExceptionCode::Exit ;
	}
	return	false ;
}


//////////////////////////////////////////////////////////////////////////////
// XvCgAj[V҂
//////////////////////////////////////////////////////////////////////////////

void WaitSprite( Sprite & sprite )
{
	while ( sprite.IsActivation() )
	{
		//  P Sleep łǂÅԏIłȂ
		GetCommand( 33 ) ;
	}
}


//////////////////////////////////////////////////////////////////////////////
// XvCgtF[hC
//////////////////////////////////////////////////////////////////////////////

void Fadein( Sprite & sprite, int nPriority, String strFileName )
{
	SpriteParam	sp ;
	sprite.LoadImage( strFileName ) ;
	//
	ImageInfo&	infImage = sprite.GetImageInfo() ;
	if ( infImage === null )
	{
		return ;
	}
	sprite.GetParameter( sp ) ;
	sp.ptDstPos = Point( 320, 240 ) ;
	sp.ptRevCenter.x = infImage.nImageWidth / 2 ;
	sp.ptRevCenter.y = infImage.nImageHeight / 2 ;
	sp.nTransparency = 0x100 ;
	sprite.SetParameter( sp ) ;
	//
	screen.Lock() ;
	screen.AddSprite( nPriority, sprite ) ;
	sprite.SetVisible( true ) ;
	sprite.SetBlendingEnvelope( 0 ) ;
	sprite.BeginActivation( 1000 ) ;
	screen.Unlock() ;
	//
	WaitSprite( sprite ) ;
}


//////////////////////////////////////////////////////////////////////////////
// XvCgtF[hAEg
//////////////////////////////////////////////////////////////////////////////

void Fadeout( Sprite & sprite )
{
	screen.Lock() ;
	sprite.SetBlendingEnvelope( 0x100 ) ;
	sprite.BeginActivation( 1000 ) ;
	screen.Unlock() ;
	//
	WaitSprite( sprite ) ;
	//
	screen.Lock() ;
	screen.DetachSprite( sprite ) ;
	screen.Unlock() ;
}


//////////////////////////////////////////////////////////////////////////////
// C[v
//////////////////////////////////////////////////////////////////////////////

void Run( void )
{
	//
	// XvCg
	//
	DraggableSprite	sprite ;
	sprite.LoadImages( "dragit_n.png", "dragit_f.png" ) ;
	sprite.SetMouseInterface( sprite ) ;
	sprite.SetKeyInterface( sprite ) ;
	//
	// XvCg\
	//
	screen.Lock() ;
	screen.AddSprite( 0, sprite ) ;
	sprite.SetVisible( true ) ;
	sprite.SetFocus() ;			// L[͂ɕKv
	screen.Unlock() ;
	//
	// ̖[v
	//
	for ( ; ; )
	{
		GetCommand() ;
	}
}


//////////////////////////////////////////////////////////////////////////////
// XvCg̃tbNNX
//////////////////////////////////////////////////////////////////////////////

// 摜ǂݍ
//////////////////////////////////////////////////////////////////////////////
void DraggableSprite::LoadImages( String strNormal, String strHilight )
{
	m_rsNormal.LoadImage( strNormal ) ;
	m_rsHilight.LoadImage( strHilight ) ;
	AttachImage( m_rsNormal ) ;
}

// SpriteMouseInterface I[o[Ch
//////////////////////////////////////////////////////////////////////////////
void DraggableSprite::OnMouseMove
			( Sprite& sprite, int xPos, int yPos )
{
	AttachImage( m_rsHilight ) ;
	if ( m_flagTracking )
	{
		MovePosition( xPos - m_ptTrackBase.x, yPos - m_ptTrackBase.y ) ;
	}
}

void DraggableSprite::OnMouseLeave( Sprite& sprite )
{
	AttachImage( m_rsNormal ) ;
}

bool DraggableSprite::OnMouseWheel
			( Sprite& sprite, int zDelta, int xPos, int yPos )
{
	return	false ;
}

bool DraggableSprite::OnLButtonDown
			( Sprite& sprite, int xPos, int yPos )
{
	m_flagTracking = true ;
	m_ptTrackBase = Point( xPos, yPos ) - GetPosition() ;
	SetCapture() ;
	return	true ;
}

bool DraggableSprite::OnLButtonUp
			( Sprite& sprite, int xPos, int yPos )
{
	m_flagTracking = false ;
	ReleaseCapture() ;
	return	true ;
}

bool DraggableSprite::OnLButtonDblClk
			( Sprite& sprite, int xPos, int yPos )
{
	return	false ;
}

bool DraggableSprite::OnRButtonDown
			( Sprite& sprite, int xPos, int yPos )
{
	return	false ;
}

bool DraggableSprite::OnRButtonUp
			( Sprite& sprite, int xPos, int yPos )
{
	return	false ;
}

bool DraggableSprite::OnRButtonDblClk
			( Sprite& sprite, int xPos, int yPos )
{
	return	false ;
}

// SpriteKeyInterface I[o[Ch
//////////////////////////////////////////////////////////////////////////////
bool DraggableSprite::OnKeyDown( Sprite& sprite, int nVirtKey )
{
	Point	pos = GetPosition() ;
	switch ( nVirtKey )
	{
	case	VK_UP:
		MovePosition( pos.x, pos.y - 8 ) ;
		return	true ;
	case	VK_DOWN:
		MovePosition( pos.x, pos.y + 8 ) ;
		return	true ;
	case	VK_LEFT:
		MovePosition( pos.x - 8, pos.y ) ;
		return	true ;
	case	VK_RIGHT:
		MovePosition( pos.x + 8, pos.y ) ;
		return	true ;
	}
	return	false ;
}

bool DraggableSprite::OnKeyUp( Sprite& sprite, int nVirtKey )
{
	return	false ;
}



