
#include <cotopha.h>


shared Window		screen ;
shared InputFilter	input ;

WndSpriteCmd & GetCommand( int nTimeout = INFINITE ) ;
bool DispatchCommand( WndSpriteCmd & wscmd ) ;

enum	ExceptionCode
{
	Exit
} ;


int main()
{
	screen.CreateDisplay
		( "Window Sample", Window::Copperation::Window, 640, 480 ) ;
	screen.SetOptionalFuncFlag
		( screen.GetOptionalFuncFlag()
			| Window::Flag::AllowClose
			| Window::Flag::AllowMinimize
			| Window::Flag::VariableWindowSize
			| Window::Flag::AllowMaximize ) ;
	screen.ShowCursor( true ) ;
	screen.EnableCommandQueue( true ) ;

	InputEvent	evIn, evOut ;
	evIn.idType = idKeyboard ;
	evIn.iKeyNum = VK_ESCAPE ;
	evOut.idType = idCommand ;
	evOut.strCommand = SysCommandId::AppExit ;
	input.AddFilter( evIn, evOut ) ;

	input.OpenFilter( InputFilter::Type::Below, screen ) ;

	try
	{
		for ( ; ; )
		{
			GetCommand() ;
		}
	}
	catch ( int code )
	{
	}

	screen.CloseDisplay() ;

	return	0 ;
}


WndSpriteCmd & GetCommand( int nTimeout )
{
	WndSpriteCmd &	wscmd = WndSpriteCmd ;
	if ( screen.GetCommand( wscmd, nTimeout ) == eslErrSuccess )
	{
		if ( !DispatchCommand( wscmd ) )
		{
			return	wscmd ;
		}
	}
	return	null ;
}


bool DispatchCommand( WndSpriteCmd & wscmd )
{
	switch ( wscmd.strID )
	{
	case	SysCommandId::AppExit:
		throw	ExceptionCode::Exit ;
	}
	return	false ;
}


